//
//  TSDiscoverListVC.swift
//  AIRingtone
//
//  Created by 100Years on 2025/3/17.
//

class TSDiscoverListVC: TSBaseVC {
    
    var ringCategoryModel:TSRingCategoryModel
    init(ringCategoryModel: TSRingCategoryModel) {
        self.ringCategoryModel = ringCategoryModel
        super.init()
    }
    
    @MainActor required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    lazy var viewModel:TSDiscoverListVM = {
        let viewModel = TSDiscoverListVM(categoryID:ringCategoryModel.categoryId,animationView: self.view)
        return viewModel
    }()
    

    lazy var collectionComponent: TSCollectionViewComponent = {
        let layout = UICollectionViewFlowLayout()
        let cp = TSCollectionViewComponent(frame: CGRect.zero, layout: layout, attributes: [ :])
        cp.collectionView.contentInset = UIEdgeInsets(top: 0, left: 0, bottom: 20, right: 0)
        
//        cp.itemDidSelectedHandler = { [weak self] (object, indexPath) in
//            guard let self = self else { return }
//            if indexPath.section == 0{
//                kPushVC(target: self, modelVC: TSAIPhotoVC())
//                return
//            }
//
//            if let sections = viewModel.colDataArray.safeObj(At: indexPath.section) as? TSColVVMSectionModel{
//                let browseVC = TSThemeBrowseVC(currentIndex: indexPath.row, themeViewModel: viewModel) { [weak self]  in
//                    guard let self = self else { return }
//                    collectionComponent.reloadData()
//                }
//                kPushVC(target: self, modelVC: browseVC)
//            }
//        }
        
        cp.collectionView.addRefresh{ [weak self]  in
            guard let self = self else { return }
            viewModel.reloadAllData { [weak self] success  in
                guard let self = self else { return }
                if success {
                    collectionComponent.clear()
                    collectionComponent.reloadView(with:viewModel.colDataArray)
                }
                collectionComponent.collectionView.endRefreshing()
            }
        }
        
        cp.collectionView.addLoadMore { [weak self]  in
            guard let self = self else { return }
            
            viewModel.getMoreData { [weak self] success,haveMore in
                guard let self = self else { return }
                if success {
                    collectionComponent.reloadData()
                }
                collectionComponent.collectionView.endRefreshing(noMore: !haveMore)
            }
        }
        return cp
    }()
    
    
    override func createView() {
        addNormalNavBarView()
        setPageTitle(ringCategoryModel.title)
        _ = setNavigationItem("", imageName: "tutorials", direction: .right, action: #selector(clickRight))
        
        contentView.addSubview(collectionComponent.collectionView)
        collectionComponent.collectionView.snp.makeConstraints { make in
            make.edges.equalToSuperview()
        }

    }
    
    override func dealThings() {
        viewModel.getData {[weak self] success in
            guard let self = self else { return }
            if success {
                collectionComponent.clear()
                collectionComponent.reloadView(with:viewModel.colDataArray)
            }
        }
    }
    
    @objc func clickRight(){
        let browseVC = TSThemeTutorialsVC()
        kPushVC(target: self, modelVC: browseVC)
    }
}

